//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.

#include <stdio.h>		//  /
#include <stdlib.h>		// atoi, calloc   . 
#include <fcntl.h>		//  O_...
#include <sys/stat.h>	//  
#include <sys/types.h>	// getpid()
#include <mqueue.h>		//  
#include <unistd.h>		// getopt
#include <string.h>		//  
#include "CGI_auth.h"
#define OUT_QUEUE "/output"


mqd_t mq_cmd = -1, mq_out = -1;
ssize_t mq_size = 0;
char *out_buf;
struct mq_attr attr;

void print_messages(){
		ssize_t cur, n;
		unsigned prio;
		mq_getattr(mq_out, &attr);
		cur = attr.mq_curmsgs;
		while(cur-- > 0){
			n = mq_receive(mq_out, out_buf, attr.mq_msgsize, &prio);
			if(n < 1) continue;
			out_buf[n] = 0;
			printf("%s", out_buf);
		}
}

int main(int argc, char **argv){
	printf("Content-type: multipart/form-data; charset=koi8-r\n\n");
/*	if(get_auth_level() < FullLevel){
		printf("     \n");
		exit(0);
	}*/
	mq_out = mq_open(OUT_QUEUE, O_RDONLY|O_NONBLOCK);
	if(mq_out < 0){printf("   \n"); exit(1);}
	if(mq_getattr(mq_out, &attr) < 0){printf(" \n");exit(1);}
	mq_size = attr.mq_msgsize;
	if((out_buf= (char*)calloc(mq_size, 1)) == NULL){printf("   \n");exit(1);}
	mq_size--; //     
	print_messages();
	free(out_buf);
	mq_close(mq_out);
	exit(0);
}

