#ifndef MOTOR_FUNC_H
#define MOTOR_FUNC_H
#include "fiber_guide_cgi.h"

#ifdef MOTOR_FUNC_C
#define FeedBack	0.3		//      ( )
/********************    *****************
 *      ,   5  :
 * 		  
 * 000		0		0
 * 001		32		1
 * 010		64		2
 * 011		96		3
 * 100		128		4
 * 101		160		5
 * 110		192		6
 * 111		224		7
 */
#define L_Motor		32		//   
#define X_Motor		96		// X  Y 
#define Y_Motor		64
#define Lamps		128		//   
#define Shutt		0		// 
#define G_Motor		160		//  
#define C_Motor		224		//  
#define Focus		192		//  
/***********************************************************************/
/*
 *   - 210 ;
 * : 
 *   ~19
 *   :   210,  -   105
 */
#define XYM_steps	(105)		//  -     
#define LM_Steps	(3750)	//        

#define COS_TH	(-0.7071068)	//       
#define SIN_TH	(-0.7071068)	// 		  

#include "signals.h"

#define CMSPAR 010000000000

#define ScaleX  	(0.54) //      
#define ScaleY  	(0.54)
#define MIN_STEPS	(2)		//  -    
#define MIN_DR		(0.75)	//    ( )  
extern double dtime();
unsigned char crc(unsigned char data); // 
void tty_init(); //    RS-232
int read_tty_raw(); //   ()  
int read_tty(unsigned char* ctrlr); //    ,  ctrlr   ,    
bool write_tty_raw(unsigned char wb); //   
bool write_tty(unsigned char wb, unsigned char cno); //    cno
bool send_cmd(unsigned char cmd, unsigned char flag, unsigned char cno); //     :  cmd  cno,  flag == 1;  cmd,  flag==0
bool write_byte(unsigned char byte, unsigned char cno); //   (   )
bool sendword(unsigned int data, unsigned char cno); //   
//bool tmrset(unsigned char cno); //      cno
bool init_ctrlr(unsigned char cno); //   INIT  cno   
//bool set_timer(unsigned char cno, float time); //     cno  time
//void termsig(char term);
//void terminals(unsigned char cno); //    
void error(unsigned char err, unsigned char cno); //  
//void tty_sig(unsigned char rb, unsigned char cno); //     (, )
bool gtmid(unsigned char cno); //       cno
bool goto_middle(); //     
void move_to_center(); //  XY-, goto_middle, 
bool init_motor(unsigned char cno); //    cno ( XY)
void init_XY(); //    XY
bool read_ctrlr(); //      
void step_goto(double *xold, double *yold, double xnew, double ynew); //     xnew, ynew.    ,  xold, yold   
void manage_lamps(char lamp); //      ( lamp . img_functions.h struct Params)
void shutter(bool flag);
void change_pos(int newpos, int *curpos, unsigned char cno);
char *cnameByNum(unsigned char cno);

#endif //MOTOR_FUNC_C
#define CH_OBJ	(-1024) // ""    
void stop_all_devices(); //       ( )
void *controllers_thread(); //   
#endif //MOTOR_FUNC_H
