#ifndef V4L2CONTROL_H
#define V4L2CONTROL_H
#include "fiber_guide_cgi.h"

#define GRAB_DEVICE "/dev/video0"
char* grab_dev;
struct Buffs{
	int nbuf_cur; //    
	size_t length;
} *Buffers;
#define CLEAR(x) memset (&(x), 0, sizeof (x))

struct buffer {
	void * start;
	size_t length;
};
	#ifdef __TEST__
extern double dtime();
	#endif
struct buffer * buffers;
unsigned int n_buffers;
int  grab_fd, shmid;
static bool init_read(unsigned int buffer_size);
static bool init_mmap(unsigned int *bufsize);
static bool init_userp(unsigned int buffer_size);
static void init_buffers(unsigned int buffer_size);
static void start_capturing();
void grab_init(char *dev);
void grab_set_chan(int ch_num);
unsigned char* grab_next(int *width, int *height);
void change_controls(int brightness, int contrast);
#endif //V4L2CONTROL_H

